FrameSize = 7

function len(T)
    local count = 0
    for _ in pairs(T) do count = count + 1 end
    return count
end

function DrawRect(x, y, w, h, color)
    UiPush()
        UiColor(color[1], color[2], color[3])
        UiTranslate(x + FrameSize, y + FrameSize)
        UiAlign("left top")
        UiRect(w, h)
    UiPop()
end

function DrawImage(image, x, y)
    UiPush()
        UiTranslate(x + FrameSize, y + FrameSize)
        UiAlign("left top")
        UiImage(image)
    UiPop()
end

function DrawText(string, x, y, fontSize, fontName, color)
    UiPush()
        UiColor(color[1], color[2], color[3])
        UiTranslate(x + FrameSize, y + FrameSize)
        UiAlign("left top")
        UiFont(fontName, fontSize)
        UiText(string)
    UiPop()
end

function DrawGBNumber(number, x, y)
    local posX = x - 6
    for digit in string.gmatch(string.reverse(number), "%d") do
        DrawImage("tetris_assets/sprites/num"..digit..".png", posX, y)
        posX = posX - 8
    end
end

function RandomInt(min, max)
    return math.floor(math.random() * (max + 1 - min)) + min
end

function RenderTetromino(piece, type)
    local x_abs = 120
    local y_abs = 104

    for i, block in ipairs(piece) do
        local posX = (block % 4) * 8 + x_abs
        local posY = math.floor(block / 4) * 8 + y_abs
        DrawImage("tetris_assets/sprites/block"..type..".png", posX, posY)
    end
end

function ResetControls()
    SetBool("gameboy.controller.keys.left", false)
    SetBool("gameboy.controller.keys.up", false)
    SetBool("gameboy.controller.keys.right", false)
    SetBool("gameboy.controller.keys.down", false)
    SetBool("gameboy.controller.keys.a", false)
    SetBool("gameboy.controller.keys.b", false)
    SetBool("gameboy.controller.keys.start", false)
    SetBool("gameboy.controller.keys.select", false)
end

function GetSpeedMult()
    local fps60 = 0.0166667
    local fpsReal = GetTimeStep()
    return fpsReal / fps60
end