#include "drawing.lua"
#include "tetriscore.lua"

function resetConsole()
    currentScreen = 0
    onePlayer = true
    startBeenPressed = false
    selectBeenPressed = false
    aBeenPressed = false
    startTimer = 0
    aType = true
    song = 0
    blinkTimer = 0
    modeSelected = false
    blink = false
    difficulty = 0
end

function draw(dt)
    if GetBool("Reset") then
        resetConsole()
        SetBool("Reset", false)
    end


    if currentScreen == 0 then 
        DrawImage("tetris_assets/screens/startscreen.png", 0, 0)
        startTimer = startTimer + GetSpeedMult()
        if startTimer >= 480 then
            currentScreen = 1
        end
    elseif currentScreen == 1 then
        DrawImage("tetris_assets/screens/main_menu.png", 0, 0)
        UiSoundLoop("tetris_assets/music/menu_loop.ogg")
        DrawImage("tetris_assets/sprites/mm_cursor.png", onePlayer and 9 or 89, 113)
    elseif currentScreen == 2 then
        DrawImage("tetris_assets/screens/mode_select.png", 0, 0)

        -- Mode buttons
        DrawImage("tetris_assets/sprites/aTypeOrange.png", 25, 41)
        DrawImage("tetris_assets/sprites/bTypeOrange.png", 89, 41)

        -- Song buttons
        DrawImage("tetris_assets/sprites/aTypeOrange.png", 25, 97)
        DrawImage("tetris_assets/sprites/bTypeOrange.png", 89, 97)
        DrawImage("tetris_assets/sprites/cTypeOrange.png", 25, 113)
        DrawImage("tetris_assets/sprites/offOrange.png", 97, 113)

        if song == 0 then 
            UiSoundLoop("tetris_assets/music/typeA.ogg")
        elseif song == 1 then
            UiSoundLoop("tetris_assets/music/typeB.ogg")
        elseif song == 2 then
            UiSoundLoop("tetris_assets/music/typeC.ogg")
        end

        if modeSelected then
            if aType then
                DrawImage("tetris_assets/sprites/aTypeBlue.png", 25, 41)
            else 
                DrawImage("tetris_assets/sprites/bTypeBlue.png", 89, 41)
            end
        else
            if song == 0 then 
                DrawImage("tetris_assets/sprites/aTypeBlue.png", 25, 97)
            elseif song == 1 then
                DrawImage("tetris_assets/sprites/bTypeBlue.png", 89, 97)
            elseif song == 2 then
                DrawImage("tetris_assets/sprites/cTypeBlue.png", 25, 113)
            else 
                DrawImage("tetris_assets/sprites/offBlue.png", 97, 113)
            end
        end

        if blink then
            if modeSelected then
                if song == 0 then 
                    DrawImage("tetris_assets/sprites/aTypeBlue.png", 25, 97)
                elseif song == 1 then
                    DrawImage("tetris_assets/sprites/bTypeBlue.png", 89, 97)
                elseif song == 2 then
                    DrawImage("tetris_assets/sprites/cTypeBlue.png", 25, 113)
                else 
                    DrawImage("tetris_assets/sprites/offBlue.png", 97, 113)
                end
            else
                if aType then
                    DrawImage("tetris_assets/sprites/aTypeBlue.png", 25, 41)
                else 
                    DrawImage("tetris_assets/sprites/bTypeBlue.png", 89, 41)
                end
            end
        end

        if blinkTimer >= 20 then
            blinkTimer = 0
            blink = not blink
        end

        blinkTimer = blinkTimer + GetSpeedMult()
    elseif currentScreen == 3 then
        DrawImage("tetris_assets/screens/atype_settings.png", 0, 0)

        if song == 0 then 
            UiSoundLoop("tetris_assets/music/typeA.ogg")
        elseif song == 1 then
            UiSoundLoop("tetris_assets/music/typeB.ogg")
        elseif song == 2 then
            UiSoundLoop("tetris_assets/music/typeC.ogg")
        end

        if blink then
            if difficulty == 0 then 
                DrawImage("tetris_assets/sprites/num0.png", 41, 49)
            elseif difficulty == 1 then
                DrawImage("tetris_assets/sprites/num1.png", 57, 49)
            elseif difficulty == 2 then
                DrawImage("tetris_assets/sprites/num2.png", 73, 49)
            elseif difficulty == 3 then
                DrawImage("tetris_assets/sprites/num3.png", 89, 49)
            elseif difficulty == 4 then
                DrawImage("tetris_assets/sprites/num4.png", 105, 49)
            elseif difficulty == 5 then
                DrawImage("tetris_assets/sprites/num5.png", 41, 65)
            elseif difficulty == 6 then
                DrawImage("tetris_assets/sprites/num6.png", 57, 65)
            elseif difficulty == 7 then
                DrawImage("tetris_assets/sprites/num7.png", 73, 65)
            elseif difficulty == 8 then
                DrawImage("tetris_assets/sprites/num8.png", 89, 65)
            elseif difficulty == 9 then
                DrawImage("tetris_assets/sprites/num9.png", 105, 65)
            end
        end


        if blinkTimer >= 20 then
            blinkTimer = 0
            blink = not blink
        end
        blinkTimer = blinkTimer + GetSpeedMult()
    elseif currentScreen == 4 then
        DrawImage("tetris_assets/screens/game.png", 0, 0)
        RunGameLoop()
    end

    --Menu
    if GetBool("gameboy.controller.keys.start") then
        if currentScreen == 0 and startTimer >= 240 then 
            currentScreen = 1
        elseif currentScreen == 1 and onePlayer then 
            currentScreen = 2
        elseif currentScreen == 2 then 
            currentScreen = 3
            UiSound("tetris_assets/sfx/mode_selected.ogg", 0.5)
        elseif currentScreen == 3 then
            reset_game()
            currentScreen = 4
        end
    end

    if GetBool("gameboy.controller.keys.select") then
        if currentScreen == 1 then
            onePlayer = not onePlayer
        end
    end

    if GetBool("gameboy.controller.keys.right") then
        if currentScreen == 2 and not modeSelected then
            if aType then 
                aType = false
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        elseif currentScreen == 2 and modeSelected then
            if song == 0 or song == 2 then
                song = song + 1
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        elseif currentScreen == 3 then
            if difficulty < 9 then
                difficulty = difficulty + 1
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        end
    elseif GetBool("gameboy.controller.keys.left") then
        if currentScreen == 2 and not modeSelected then
            if not aType then 
                aType = true
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        elseif currentScreen == 2 and modeSelected then
            if song == 1 or song == 3 then
                song = song - 1
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        elseif currentScreen == 3 then
            if difficulty > 0 then
                difficulty = difficulty - 1
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        end
    elseif GetBool("gameboy.controller.keys.up") then
        if currentScreen == 2 and modeSelected then
            if song > 1 then
                song = song - 2
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        elseif currentScreen == 3 then
            if difficulty > 4 then
                difficulty = difficulty - 5
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        end
    elseif GetBool("gameboy.controller.keys.down") then
        if currentScreen == 2 and modeSelected then
            if song < 2 then
                song = song + 2
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        elseif currentScreen == 3 then
            if difficulty < 5 then
                difficulty = difficulty + 5
                UiSound("tetris_assets/sfx/click.ogg", 0.5)
            end
        end
    end

    if GetBool("gameboy.controller.keys.b") then
        if currentScreen == 2 then
            if modeSelected then
                currentScreen = 3
                modeSelected = false
                UiSound("tetris_assets/sfx/mode_selected.ogg", 0.5)
            end
            modeSelected = true
        elseif currentScreen == 3 then
            reset_game()
            currentScreen = 4
        end
    end

    if GetBool("gameboy.controller.keys.a") then
        if currentScreen == 2 then
            modeSelected = false
        elseif currentScreen == 3 then
            currentScreen = 2
        end
    end

    DrawImage("tetris_assets/tv_frame.png", -FrameSize, -FrameSize)
    ResetControls()
end