local type1 = {{1, 5, 9, 13},{4, 5, 6, 7}}
local type2 = {{4, 5, 9, 10},{2, 6, 5, 9}}
local type3 = {{6, 7, 9, 10},{1, 5, 6, 10}}
local type4 = {{1, 2, 5, 9},{0, 4, 5, 6},{1, 5, 9, 8},{4, 5, 6, 10}}
local type5 = {{1, 2, 6, 10},{5, 6, 7, 9},{2, 6, 10, 11},{3, 5, 6, 7}}
local type6 = {{1, 4, 5, 6},{1, 4, 5, 9},{4, 5, 6, 9},{1, 5, 6, 9}}
local type7 = {{1, 2, 5, 6}}

Figure = {}
function Figure:new(x, y)

    local obj= {}
        obj.x = x
        obj.y = y
        obj.type = RandomInt(1, 7)
        obj.rotation = 1
    
        function obj:image()
            if self.type == 1 then
                return type1[self.rotation]
            elseif self.type == 2 then
                return type2[self.rotation]
            elseif self.type == 3 then
                return type3[self.rotation]
            elseif self.type == 4 then
                return type4[self.rotation]
            elseif self.type == 5 then
                return type5[self.rotation]
            elseif self.type == 6 then
                return type6[self.rotation]
            elseif self.type == 7 then
                return type7[self.rotation]
            end
        end
    
        function obj:rotate()
            local rotCount = 1
            if self.type == 1 then
                rotCount = 2
            elseif self.type == 2 then
                rotCount = 2
            elseif self.type == 3 then
                rotCount = 2
            elseif self.type == 4 then
                rotCount = 4
            elseif self.type == 5 then
                rotCount = 4
            elseif self.type == 6 then
                rotCount = 4
            else
                rotCount = 1
            end

            local newRot = self.rotation + 1
            if newRot > rotCount then
                newRot = 1
            end

            self.rotation = newRot
        end

    setmetatable(obj, self)
    self.__index = self; return obj
end

function isIn(arr, val)
    for i, v in ipairs(arr) do
        if v == val then
            return true
        end
    end
    return false
end
----------------------------
-- Main game loop
----------------------------
local counter = 0
local score = 0
local state = "start"
local field = {
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0},
    {0,0,0,0,0,0,0,0,0,0}
}
local speed = {53,49,45,41,37,33,28,22,17,11,10,9,8,7,6,6,5,5,4,4,3}
local height = 18
local width = 10
local figure = nil
local nextFigure = Figure:new(3, 0)
local linesCleared = 0
local gameoverAnimTimer = 0
local level = 0
local breaklines = false
local linebreaker = {}
local lineAnimTimer = 0

function new_figure()
    figure = nextFigure
    nextFigure = Figure:new(3, 0)
end

function intersects()
    intersection = False
    for i=1,4 do
        for j=1,4 do
            if isIn(figure:image(), (i-1) * 4 + (j-1)) then
                if i + figure.y > height or j + figure.x > width or j + figure.x <= 0 or field[i + figure.y][j + figure.x] > 0 then
                    intersection = true
                end
            end
        end
    end
    return intersection
end

function go_down()
    figure.y = figure.y + 1
    if intersects() then
        figure.y = figure.y - 1
        freeze()
    end
end

function remove_lines()
    local lines = 0
    for i=1,height do
        local zeros = 0
        for j=1,width do
            if field[i][j] == 0 then
                zeros = zeros + 1
            end
        end
        if zeros == 0 then
            lines = lines + 1
            for i1=i,2,-1 do
                for j=1,width do
                    field[i1][j] = field[i1 - 1][j]
                end
            end
        end
    end
    lineAnimTimer = 0
    breaklines = false
end

function break_lines()
    linebreaker = {}
    local lines = 0
    for i=1,height do
        local zeros = 0
        for j=1,width do
            if field[i][j] == 0 then
                zeros = zeros + 1
            end
        end
        if zeros == 0 then
            lines = lines + 1
            table.insert(linebreaker, i)
        end
    end
    if lines > 0 then
        breaklines = true
        if lines == 1 then
            score = score + (40 * (difficulty + 1))
            UiSound("tetris_assets/sfx/line_clear.ogg", 0.5)
        elseif lines == 2 then
            score = score + (100 * (difficulty + 1))
            UiSound("tetris_assets/sfx/line_clear.ogg", 0.5)
        elseif lines == 3 then
            score = score + (300 * (difficulty + 1))
            UiSound("tetris_assets/sfx/line_clear.ogg", 0.5)
        elseif lines == 4 then
            score = score + (1200 * (difficulty + 1))
            UiSound("tetris_assets/sfx/tetris.ogg", 0.5)
        end
        linesCleared = linesCleared + lines

        if linesCleared >= level * 10 + 10 and level < 20 then
            level = level + 1
            UiSound("tetris_assets/sfx/level_up.ogg", 0.7)
        end
    end
end

function freeze()
    UiSound("tetris_assets/sfx/landed.ogg", 0.5)
    for i=1,4 do
        for j=1,4 do
            if isIn(figure:image(), (i-1) * 4 + (j-1)) then
                field[i + figure.y][j + figure.x] = figure.type
            end
        end
    end
    break_lines()
    new_figure()
    if intersects() then
        UiSound("tetris_assets/sfx/gameover.ogg", 0.5)
        state = "gameover"
    end
end

function go_side(dx)
    local old_x = figure.x
    figure.x = figure.x + dx
    if intersects() then
        figure.x = old_x
    else
        UiSound("tetris_assets/sfx/move.ogg", 0.5)
    end
end

function rotate()
    old_rotation = figure.rotation
    figure:rotate()
    if intersects() then
        figure.rotation = old_rotation
    else
        UiSound("tetris_assets/sfx/rotate.ogg", 0.5)
    end
end

function reset_game()
    gameoverAnimTimer = 0
    level = difficulty
    counter = 0
    score = 0
    state = "start"
    field = {
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0}
    }
    figure = nil
    nextFigure = Figure:new(3, 0)
    linesCleared = 0
end

function RunGameLoop()
    DrawGBNumber(score, 150, 25)        -- Score
    DrawGBNumber(level, 142, 57)        -- Level
    DrawGBNumber(linesCleared, 142, 81) -- Lines
    if state == "start" then
        RenderTetromino(nextFigure:image(), nextFigure.type)
    end

    if state == "start" then
        if song == 0 then 
            UiSoundLoop("tetris_assets/music/typeA.ogg")
        elseif song == 1 then
            UiSoundLoop("tetris_assets/music/typeB.ogg")
        elseif song == 2 then
            UiSoundLoop("tetris_assets/music/typeC.ogg")
        end
    elseif state == "pause" then
        DrawImage("tetris_assets/screens/pause.png", 0, 0)
    end

    if figure == nil then
        new_figure()
    end
    counter = counter + GetSpeedMult()
    if not breaklines and (counter >= speed[level + 1] or (counter % 2 > 1 and GetBool("gameboy.controller.keys.down.down"))) then
        if state == "start" then
            go_down()
        end
        counter = 0
    end
    if not breaklines and (GetBool("gameboy.controller.keys.a") or GetBool("gameboy.controller.keys.b") or GetBool("gameboy.controller.keys.up")) then
        if state == "start" then
            rotate()
        elseif gameoverAnimTimer > height * 3 then
            ResetControls()
            currentScreen = 3
        end
    end
    if not breaklines and GetBool("gameboy.controller.keys.right") then
        if state == "start" then
            go_side(1)
        end
    end
    if not breaklines and GetBool("gameboy.controller.keys.left") then
        go_side(-1)
    end

    if GetBool("gameboy.controller.keys.start") then 
        if state == "gameover" and gameoverAnimTimer > height * 3 then
            ResetControls()
            currentScreen = 3
        elseif state == "start" then
            UiSound("tetris_assets/sfx/pause.ogg", 0.6)
            state = "pause"
        elseif state == "pause" then
            state = "start"
        end
    end

    if state ~= "pause" then
        for y, row in ipairs(field) do
            for x, block in ipairs(row) do
                if block ~= 0 then
                    local x_abs = 8 + (x * 8)
                    local y_abs = y * 8 - 8
                    DrawImage("tetris_assets/sprites/block"..block..".png", x_abs, y_abs)
                end
            end
        end
    end
    
    if figure ~= nil and state ~= "pause" then
        for i=1,4 do
            for j=1,4 do
                p = (i-1) * 4 + (j-1)
                if isIn(figure:image(), p) then
                    local x_abs = 8 * (j + 1 + figure.x)
                    local y_abs = 8 * (i - 1 + figure.y)
                    DrawImage("tetris_assets/sprites/block"..figure.type..".png", x_abs, y_abs)
                end
            end
        end
    end

    if breaklines then
        if lineAnimTimer % 8 > 3 then
            for i, line in ipairs(linebreaker) do
                local y = (line - 1) * 8 
                DrawRect(16, y, 80, 8, {0.87059, 0.58039, 0.29020})
            end
        end

        if lineAnimTimer > 30 then
            remove_lines()
        end

        lineAnimTimer = lineAnimTimer + GetSpeedMult()
    end

    if state == "gameover" then
        local drawLinesCount = height - math.ceil(gameoverAnimTimer)
        local h = height
        if gameoverAnimTimer > height then
            h = height + height - gameoverAnimTimer 
            DrawImage("tetris_assets/screens/gameover.png", 0, 0)
        end
        if gameoverAnimTimer <= height * 2 then
            for i=h,drawLinesCount,-1 do
                local y = 8 * (i - 1)
                DrawImage("tetris_assets/sprites/gameover_line.png", 16, y)
            end
        end
        
        gameoverAnimTimer = gameoverAnimTimer + (GetSpeedMult() / 2)
    end
end